From 1dab865a48a4c3db6217258d55d7e70d23d4774e Mon Sep 17 00:00:00 2001
From: Greg Burd <greg@burd.me>
Date: Fri, 14 Nov 2025 08:43:14 -0500
Subject: [PATCH v4 2/3] Update the remainder of catalog updates using the new
 APIs

NOTE: This is a work-in-progress commit, some of the files (aclchk.c,
heap.c) have been adapted to use the proposed macros, the rest remain
unchanged and use the ealier macros.

Apply all necessary changes to use the new macros for catalog tuples.
This commit finishes the work started in the previous one.  There should
be no behavioral changes resulting from these commits.
---
 src/backend/catalog/aclchk.c                | 159 +++---
 src/backend/catalog/heap.c                  | 359 ++++++------
 src/backend/catalog/index.c                 | 177 +++---
 src/backend/catalog/partition.c             |   5 +-
 src/backend/catalog/pg_attrdef.c            |  38 +-
 src/backend/catalog/pg_cast.c               |  18 +-
 src/backend/catalog/pg_collation.c          |  40 +-
 src/backend/catalog/pg_conversion.c         |  22 +-
 src/backend/catalog/pg_db_role_setting.c    |  54 +-
 src/backend/catalog/pg_depend.c             |  72 +--
 src/backend/catalog/pg_enum.c               |  45 +-
 src/backend/catalog/pg_inherits.c           |  14 +-
 src/backend/catalog/pg_largeobject.c        |  22 +-
 src/backend/catalog/pg_namespace.c          |  24 +-
 src/backend/catalog/pg_operator.c           | 119 ++--
 src/backend/catalog/pg_parameter_acl.c      |  11 +-
 src/backend/catalog/pg_proc.c               | 110 ++--
 src/backend/catalog/pg_publication.c        |  36 +-
 src/backend/catalog/pg_range.c              |  20 +-
 src/backend/catalog/pg_shdepend.c           |  67 +--
 src/backend/catalog/pg_subscription.c       |  86 ++-
 src/backend/catalog/pg_type.c               | 211 ++++----
 src/backend/catalog/toasting.c              |   7 +-
 src/backend/commands/amcmds.c               |  15 +-
 src/backend/commands/cluster.c              |  80 +--
 src/backend/commands/collationcmds.c        |  20 +-
 src/backend/commands/comment.c              |  51 +-
 src/backend/commands/dbcommands.c           | 133 +++--
 src/backend/commands/event_trigger.c        |  42 +-
 src/backend/commands/extension.c            | 107 ++--
 src/backend/commands/foreigncmds.c          | 205 +++----
 src/backend/commands/functioncmds.c         |  69 +--
 src/backend/commands/indexcmds.c            |  16 +-
 src/backend/commands/matview.c              |   7 +-
 src/backend/commands/opclasscmds.c          |  82 +--
 src/backend/commands/operatorcmds.c         |  54 +-
 src/backend/commands/policy.c               |  98 ++--
 src/backend/commands/proclang.c             |  44 +-
 src/backend/commands/publicationcmds.c      |  85 ++-
 src/backend/commands/schemacmds.c           |  25 +-
 src/backend/commands/seclabel.c             |  57 +-
 src/backend/commands/sequence.c             |  32 +-
 src/backend/commands/statscmds.c            |  50 +-
 src/backend/commands/subscriptioncmds.c     | 187 +++----
 src/backend/commands/tablecmds.c            | 569 ++++++++++++--------
 src/backend/commands/tablespace.c           |  47 +-
 src/backend/commands/trigger.c              | 109 ++--
 src/backend/commands/tsearchcmds.c          | 169 +++---
 src/backend/commands/typecmds.c             | 136 ++---
 src/backend/commands/user.c                 | 228 +++-----
 src/backend/replication/logical/origin.c    |  10 +-
 src/backend/replication/logical/tablesync.c |  22 +-
 src/backend/replication/logical/worker.c    |  17 +-
 src/backend/rewrite/rewriteDefine.c         |  60 +--
 src/backend/rewrite/rewriteSupport.c        |   6 +-
 src/backend/statistics/extended_stats.c     |  65 ++-
 src/backend/statistics/relation_stats.c     |  40 +-
 src/backend/storage/large_object/inv_api.c  |  53 +-
 src/backend/utils/cache/relcache.c          |  20 +-
 59 files changed, 2256 insertions(+), 2470 deletions(-)

diff --git a/src/backend/catalog/aclchk.c b/src/backend/catalog/aclchk.c
index a431fc0926f..35a38f01a9d 100644
--- a/src/backend/catalog/aclchk.c
+++ b/src/backend/catalog/aclchk.c
@@ -1318,8 +1318,7 @@ SetDefaultACL(InternalDefaultACL *iacls)
 	else
 	{
 		Datum		values[Natts_pg_default_acl] = {0};
-		bool		nulls[Natts_pg_default_acl] = {0};
-		bool		replaces[Natts_pg_default_acl] = {0};
+		bool		nulls[Natts_pg_default_acl] = {false};
 		Oid			defAclOid;
 
 		if (isNew)
@@ -1327,26 +1326,28 @@ SetDefaultACL(InternalDefaultACL *iacls)
 			/* insert new entry */
 			defAclOid = GetNewOidWithIndex(rel, DefaultAclOidIndexId,
 										   Anum_pg_default_acl_oid);
-			values[Anum_pg_default_acl_oid - 1] = ObjectIdGetDatum(defAclOid);
-			values[Anum_pg_default_acl_defaclrole - 1] = ObjectIdGetDatum(iacls->roleid);
-			values[Anum_pg_default_acl_defaclnamespace - 1] = ObjectIdGetDatum(iacls->nspid);
-			values[Anum_pg_default_acl_defaclobjtype - 1] = CharGetDatum(objtype);
-			values[Anum_pg_default_acl_defaclacl - 1] = PointerGetDatum(new_acl);
+			HeapTupleSetValue(pg_default_acl, oid, ObjectIdGetDatum(defAclOid), values);
+			HeapTupleSetValue(pg_default_acl, defaclrole, ObjectIdGetDatum(iacls->roleid), values);
+			HeapTupleSetValue(pg_default_acl, defaclnamespace, ObjectIdGetDatum(iacls->nspid), values);
+			HeapTupleSetValue(pg_default_acl, defaclobjtype, CharGetDatum(objtype), values);
+			HeapTupleSetValue(pg_default_acl, defaclacl, PointerGetDatum(new_acl), values);
 
 			newtuple = heap_form_tuple(RelationGetDescr(rel), values, nulls);
-			CatalogTupleInsert(rel, newtuple);
+			CatalogTupleInsert(rel, newtuple, NULL);
 		}
 		else
 		{
+			Bitmapset  *updated = NULL;
+
 			defAclOid = ((Form_pg_default_acl) GETSTRUCT(tuple))->oid;
 
 			/* update existing entry */
-			values[Anum_pg_default_acl_defaclacl - 1] = PointerGetDatum(new_acl);
-			replaces[Anum_pg_default_acl_defaclacl - 1] = true;
+			HeapTupleUpdateValue(pg_default_acl, defaclacl, PointerGetDatum(new_acl), values, nulls, updated);
+
+			newtuple = heap_update_tuple(tuple, RelationGetDescr(rel), values, nulls, updated);
+			CatalogTupleUpdate(rel, &newtuple->t_self, newtuple, updated, NULL);
 
-			newtuple = heap_modify_tuple(tuple, RelationGetDescr(rel),
-										 values, nulls, replaces);
-			CatalogTupleUpdate(rel, &newtuple->t_self, newtuple);
+			bms_free(updated);
 		}
 
 		/* these dependencies don't change in an update */
@@ -1652,12 +1653,12 @@ ExecGrant_Attribute(InternalGrant *istmt, Oid relOid, const char *relname,
 	bool		need_update;
 	HeapTuple	newtuple;
 	Datum		values[Natts_pg_attribute] = {0};
-	bool		nulls[Natts_pg_attribute] = {0};
-	bool		replaces[Natts_pg_attribute] = {0};
+	bool		nulls[Natts_pg_attribute] = {false};
 	int			noldmembers;
 	int			nnewmembers;
 	Oid		   *oldmembers;
 	Oid		   *newmembers;
+	Bitmapset  *updated = NULL;
 
 	attr_tuple = SearchSysCache2(ATTNUM,
 								 ObjectIdGetDatum(relOid),
@@ -1744,22 +1745,21 @@ ExecGrant_Attribute(InternalGrant *istmt, Oid relOid, const char *relname,
 	 */
 	if (ACL_NUM(new_acl) > 0)
 	{
-		values[Anum_pg_attribute_attacl - 1] = PointerGetDatum(new_acl);
+		HeapTupleUpdateValue(pg_attribute, attacl, PointerGetDatum(new_acl), values, nulls, updated);
 		need_update = true;
 	}
 	else
 	{
-		nulls[Anum_pg_attribute_attacl - 1] = true;
+		HeapTupleUpdateValueNull(pg_attribute, attacl, values, nulls, updated);
 		need_update = !isNull;
 	}
-	replaces[Anum_pg_attribute_attacl - 1] = true;
 
 	if (need_update)
 	{
-		newtuple = heap_modify_tuple(attr_tuple, RelationGetDescr(attRelation),
-									 values, nulls, replaces);
+		newtuple = heap_update_tuple(attr_tuple, RelationGetDescr(attRelation),
+									 values, nulls, updated);
 
-		CatalogTupleUpdate(attRelation, &newtuple->t_self, newtuple);
+		CatalogTupleUpdate(attRelation, &newtuple->t_self, newtuple, updated, NULL);
 
 		/* Update initial privileges for extensions */
 		recordExtensionInitPriv(relOid, RelationRelationId, attnum,
@@ -1775,6 +1775,7 @@ ExecGrant_Attribute(InternalGrant *istmt, Oid relOid, const char *relname,
 	pfree(new_acl);
 
 	ReleaseSysCache(attr_tuple);
+	bms_free(updated);
 }
 
 /*
@@ -1962,8 +1963,8 @@ ExecGrant_Relation(InternalGrant *istmt)
 			Oid			grantorId;
 			HeapTuple	newtuple;
 			Datum		values[Natts_pg_class] = {0};
-			bool		nulls[Natts_pg_class] = {0};
-			bool		replaces[Natts_pg_class] = {0};
+			bool		nulls[Natts_pg_class] = {false};
+			Bitmapset  *updated = NULL;
 			int			nnewmembers;
 			Oid		   *newmembers;
 			ObjectType	objtype;
@@ -2013,13 +2014,12 @@ ExecGrant_Relation(InternalGrant *istmt)
 			nnewmembers = aclmembers(new_acl, &newmembers);
 
 			/* finished building new ACL value, now insert it */
-			replaces[Anum_pg_class_relacl - 1] = true;
-			values[Anum_pg_class_relacl - 1] = PointerGetDatum(new_acl);
+			HeapTupleUpdateValue(pg_class, relacl, PointerGetDatum(new_acl), values, nulls, updated);
 
-			newtuple = heap_modify_tuple(tuple, RelationGetDescr(relation),
-										 values, nulls, replaces);
+			newtuple = heap_update_tuple(tuple, RelationGetDescr(relation),
+										 values, nulls, updated);
 
-			CatalogTupleUpdate(relation, &newtuple->t_self, newtuple);
+			CatalogTupleUpdate(relation, &newtuple->t_self, newtuple, updated, NULL);
 			UnlockTuple(relation, &tuple->t_self, InplaceUpdateTupleLock);
 
 			/* Update initial privileges for extensions */
@@ -2032,6 +2032,7 @@ ExecGrant_Relation(InternalGrant *istmt)
 								  nnewmembers, newmembers);
 
 			pfree(new_acl);
+			bms_free(updated);
 		}
 		else
 			UnlockTuple(relation, &tuple->t_self, InplaceUpdateTupleLock);
@@ -2142,7 +2143,7 @@ ExecGrant_common(InternalGrant *istmt, Oid classid, AclMode default_privs,
 		HeapTuple	newtuple;
 		Datum	   *values = palloc0_array(Datum, RelationGetDescr(relation)->natts);
 		bool	   *nulls = palloc0_array(bool, RelationGetDescr(relation)->natts);
-		bool	   *replaces = palloc0_array(bool, RelationGetDescr(relation)->natts);
+		Bitmapset  *updated = NULL;
 		int			noldmembers;
 		int			nnewmembers;
 		Oid		   *oldmembers;
@@ -2216,14 +2217,17 @@ ExecGrant_common(InternalGrant *istmt, Oid classid, AclMode default_privs,
 		 */
 		nnewmembers = aclmembers(new_acl, &newmembers);
 
-		/* finished building new ACL value, now insert it */
-		replaces[get_object_attnum_acl(classid) - 1] = true;
+		/*
+		 * Finished building new ACL value, now insert it. NOTE: We can't use
+		 * the HeapTupleMarkColumnUpdated() macro here because
+		 * get_object_attnum_acl(classid) provides an index.
+		 */
 		values[get_object_attnum_acl(classid) - 1] = PointerGetDatum(new_acl);
+		updated = bms_add_member(updated, get_object_attnum_acl(classid) - FirstLowInvalidHeapAttributeNumber);
 
-		newtuple = heap_modify_tuple(tuple, RelationGetDescr(relation), values,
-									 nulls, replaces);
+		newtuple = heap_update_tuple(tuple, RelationGetDescr(relation), values, nulls, updated);
 
-		CatalogTupleUpdate(relation, &newtuple->t_self, newtuple);
+		CatalogTupleUpdate(relation, &newtuple->t_self, newtuple, updated, NULL);
 		UnlockTuple(relation, &tuple->t_self, InplaceUpdateTupleLock);
 
 		/* Update initial privileges for extensions */
@@ -2239,6 +2243,7 @@ ExecGrant_common(InternalGrant *istmt, Oid classid, AclMode default_privs,
 		ReleaseSysCache(tuple);
 
 		pfree(new_acl);
+		bms_free(updated);
 
 		/* prevent error when processing duplicate objects */
 		CommandCounterIncrement();
@@ -2290,8 +2295,8 @@ ExecGrant_Largeobject(InternalGrant *istmt)
 		Oid			ownerId;
 		HeapTuple	newtuple;
 		Datum		values[Natts_pg_largeobject_metadata] = {0};
-		bool		nulls[Natts_pg_largeobject_metadata] = {0};
-		bool		replaces[Natts_pg_largeobject_metadata] = {0};
+		bool		nulls[Natts_pg_largeobject_metadata] = {false};
+		Bitmapset  *updated = NULL;
 		int			noldmembers;
 		int			nnewmembers;
 		Oid		   *oldmembers;
@@ -2369,14 +2374,12 @@ ExecGrant_Largeobject(InternalGrant *istmt)
 		nnewmembers = aclmembers(new_acl, &newmembers);
 
 		/* finished building new ACL value, now insert it */
-		replaces[Anum_pg_largeobject_metadata_lomacl - 1] = true;
-		values[Anum_pg_largeobject_metadata_lomacl - 1]
-			= PointerGetDatum(new_acl);
+		HeapTupleUpdateValue(pg_largeobject_metadata, lomacl, PointerGetDatum(new_acl), values, nulls, updated);
 
-		newtuple = heap_modify_tuple(tuple, RelationGetDescr(relation),
-									 values, nulls, replaces);
+		newtuple = heap_update_tuple(tuple, RelationGetDescr(relation),
+									 values, nulls, updated);
 
-		CatalogTupleUpdate(relation, &newtuple->t_self, newtuple);
+		CatalogTupleUpdate(relation, &newtuple->t_self, newtuple, updated, NULL);
 
 		/* Update initial privileges for extensions */
 		recordExtensionInitPriv(loid, LargeObjectRelationId, 0, new_acl);
@@ -2391,6 +2394,7 @@ ExecGrant_Largeobject(InternalGrant *istmt)
 		systable_endscan(scan);
 
 		pfree(new_acl);
+		bms_free(updated);
 
 		/* prevent error when processing duplicate objects */
 		CommandCounterIncrement();
@@ -2529,16 +2533,16 @@ ExecGrant_Parameter(InternalGrant *istmt)
 			/* finished building new ACL value, now insert it */
 			HeapTuple	newtuple;
 			Datum		values[Natts_pg_parameter_acl] = {0};
-			bool		nulls[Natts_pg_parameter_acl] = {0};
-			bool		replaces[Natts_pg_parameter_acl] = {0};
+			bool		nulls[Natts_pg_parameter_acl] = {false};
+			Bitmapset  *updated = NULL;
 
-			replaces[Anum_pg_parameter_acl_paracl - 1] = true;
-			values[Anum_pg_parameter_acl_paracl - 1] = PointerGetDatum(new_acl);
+			HeapTupleUpdateValue(pg_parameter_acl, paracl, PointerGetDatum(new_acl), values, nulls, updated);
 
-			newtuple = heap_modify_tuple(tuple, RelationGetDescr(relation),
-										 values, nulls, replaces);
+			newtuple = heap_update_tuple(tuple, RelationGetDescr(relation),
+										 values, nulls, updated);
 
-			CatalogTupleUpdate(relation, &newtuple->t_self, newtuple);
+			CatalogTupleUpdate(relation, &newtuple->t_self, newtuple, updated, NULL);
+			bms_free(updated);
 		}
 
 		/* Update initial privileges for extensions */
@@ -4669,8 +4673,8 @@ recordExtensionInitPrivWorker(Oid objoid, Oid classoid, int objsubid,
 	if (HeapTupleIsValid(oldtuple))
 	{
 		Datum		values[Natts_pg_init_privs] = {0};
-		bool		nulls[Natts_pg_init_privs] = {0};
-		bool		replace[Natts_pg_init_privs] = {0};
+		bool		nulls[Natts_pg_init_privs] = {false};
+		Bitmapset  *updated = NULL;
 		Datum		oldAclDatum;
 		bool		isNull;
 		Acl		   *old_acl;
@@ -4689,13 +4693,13 @@ recordExtensionInitPrivWorker(Oid objoid, Oid classoid, int objsubid,
 		/* If we have a new ACL to set, then update the row with it. */
 		if (new_acl && ACL_NUM(new_acl) != 0)
 		{
-			values[Anum_pg_init_privs_initprivs - 1] = PointerGetDatum(new_acl);
-			replace[Anum_pg_init_privs_initprivs - 1] = true;
+			HeapTupleUpdateValue(pg_init_privs, initprivs, PointerGetDatum(new_acl), values, nulls, updated);
 
-			oldtuple = heap_modify_tuple(oldtuple, RelationGetDescr(relation),
-										 values, nulls, replace);
+			oldtuple = heap_update_tuple(oldtuple, RelationGetDescr(relation),
+										 values, nulls, updated);
 
-			CatalogTupleUpdate(relation, &oldtuple->t_self, oldtuple);
+			CatalogTupleUpdate(relation, &oldtuple->t_self, oldtuple, updated, NULL);
+			bms_free(updated);
 		}
 		else
 		{
@@ -4706,7 +4710,7 @@ recordExtensionInitPrivWorker(Oid objoid, Oid classoid, int objsubid,
 	else
 	{
 		Datum		values[Natts_pg_init_privs] = {0};
-		bool		nulls[Natts_pg_init_privs] = {0};
+		bool		nulls[Natts_pg_init_privs] = {false};
 
 		/*
 		 * Only add a new entry if the new ACL is non-NULL.
@@ -4717,19 +4721,18 @@ recordExtensionInitPrivWorker(Oid objoid, Oid classoid, int objsubid,
 		if (new_acl && ACL_NUM(new_acl) != 0)
 		{
 			/* No entry found, so add it. */
-			values[Anum_pg_init_privs_objoid - 1] = ObjectIdGetDatum(objoid);
-			values[Anum_pg_init_privs_classoid - 1] = ObjectIdGetDatum(classoid);
-			values[Anum_pg_init_privs_objsubid - 1] = Int32GetDatum(objsubid);
+			HeapTupleSetValue(pg_init_privs, objoid, ObjectIdGetDatum(objoid), values);
+			HeapTupleSetValue(pg_init_privs, classoid, ObjectIdGetDatum(classoid), values);
+			HeapTupleSetValue(pg_init_privs, objsubid, Int32GetDatum(objsubid), values);
 
 			/* This function only handles initial privileges of extensions */
-			values[Anum_pg_init_privs_privtype - 1] =
-				CharGetDatum(INITPRIVS_EXTENSION);
+			HeapTupleSetValue(pg_init_privs, privtype, CharGetDatum(INITPRIVS_EXTENSION), values);
 
-			values[Anum_pg_init_privs_initprivs - 1] = PointerGetDatum(new_acl);
+			HeapTupleSetValue(pg_init_privs, initprivs, PointerGetDatum(new_acl), values);
 
 			tuple = heap_form_tuple(RelationGetDescr(relation), values, nulls);
 
-			CatalogTupleInsert(relation, tuple);
+			CatalogTupleInsert(relation, tuple, NULL);
 
 			/* Update pg_shdepend, too. */
 			noldmembers = 0;
@@ -4828,16 +4831,16 @@ ReplaceRoleInInitPriv(Oid oldroleid, Oid newroleid,
 	else
 	{
 		Datum		values[Natts_pg_init_privs] = {0};
-		bool		nulls[Natts_pg_init_privs] = {0};
-		bool		replaces[Natts_pg_init_privs] = {0};
+		bool		nulls[Natts_pg_init_privs] = {false};
+		Bitmapset  *updated = NULL;
 
 		/* Update existing entry. */
-		values[Anum_pg_init_privs_initprivs - 1] = PointerGetDatum(new_acl);
-		replaces[Anum_pg_init_privs_initprivs - 1] = true;
+		HeapTupleUpdateValue(pg_init_privs, initprivs, PointerGetDatum(new_acl), values, nulls, updated);
 
-		newtuple = heap_modify_tuple(oldtuple, RelationGetDescr(rel),
-									 values, nulls, replaces);
-		CatalogTupleUpdate(rel, &newtuple->t_self, newtuple);
+		newtuple = heap_update_tuple(oldtuple, RelationGetDescr(rel),
+									 values, nulls, updated);
+		CatalogTupleUpdate(rel, &newtuple->t_self, newtuple, updated, NULL);
+		bms_free(updated);
 	}
 
 	/*
@@ -4964,16 +4967,16 @@ RemoveRoleFromInitPriv(Oid roleid, Oid classid, Oid objid, int32 objsubid)
 	else
 	{
 		Datum		values[Natts_pg_init_privs] = {0};
-		bool		nulls[Natts_pg_init_privs] = {0};
-		bool		replaces[Natts_pg_init_privs] = {0};
+		bool		nulls[Natts_pg_init_privs] = {false};
+		Bitmapset  *updated2 = NULL;
 
 		/* Update existing entry. */
-		values[Anum_pg_init_privs_initprivs - 1] = PointerGetDatum(new_acl);
-		replaces[Anum_pg_init_privs_initprivs - 1] = true;
+		HeapTupleUpdateValue(pg_init_privs, initprivs, PointerGetDatum(new_acl), values, nulls, updated2);
 
-		newtuple = heap_modify_tuple(oldtuple, RelationGetDescr(rel),
-									 values, nulls, replaces);
-		CatalogTupleUpdate(rel, &newtuple->t_self, newtuple);
+		newtuple = heap_update_tuple(oldtuple, RelationGetDescr(rel),
+									 values, nulls, updated2);
+		CatalogTupleUpdate(rel, &newtuple->t_self, newtuple, updated2, NULL);
+		bms_free(updated2);
 	}
 
 	/*
